	!dp = $0000
	!addr = $0000
    !rom = $800000
	!sa1 = 0
	!gsu = 0
    !sram7000 = $000000
    !sram7008 = $000000
    !ram7F9A7B = $000000
    !ram7FC700 = $000000

if read1($00FFD6) == $15
	sfxrom
	!dp = $6000
	!addr = !dp
	!gsu = 1
elseif read1($00FFD5) == $23
	sa1rom
	!dp = $3000
	!addr = $6000
	!sa1 = 1
    !rom = $000000
    !sram7000 = $2E4000
    !sram7008 = $2E6800
    !ram7F9A7B = $3E127B
    !ram7FC700 = $3DFF00
endif

;########################################
;######## Scratchs Rams [$00,$0F] #######
;########################################
!Scratch0 = $00
!Scratch1 = $01
!Scratch2 = $02
!Scratch3 = $03
!Scratch4 = $04
!Scratch5 = $05
!Scratch6 = $06
!Scratch7 = $07
!Scratch8 = $08
!Scratch9 = $09
!ScratchA = $0A
!ScratchB = $0B
!ScratchC = $0C
!ScratchD = $0D
!ScratchE = $0E
!ScratchF = $0F

;########################################
;############## Counters ################
;########################################
!TrueFrameCounter = $13
!EffectiveFrameCounter = $14

;########################################
;############## Control #################
;########################################
!ButtonPressed_BYETUDLR = $15
!ButtonDown_BYETUDLR = $16
!ButtonPressed_AXLR0000 = $17
!ButtonDown_AXLR0000 = $18

;########################################
;############## Layers ##################
;########################################
!Layer1X = $1A
!Layer1Y = $1C
!Layer2X = $1E
!Layer2Y = $20
!Layer3X = $22
!Layer3Y = $24

;########################################
;############## Player ##################
;########################################
!PlayerX = $94
!PlayerY = $96
!PlayerXSpeed = $7B
!PlayerYSpeed = $7D
!PowerUp = $19
!Lives = $0DBE|!addr
!Coins = $0DBF|!addr
!ItemBox = $0DC2|!addr
!PlayerInAirFlag = $72
!PlayerDuckingFlag = $73
!PlayerClimbingFlag_N00SIFHB = $74
!PlayerWaterFlag = $75
!PlayerDirection = $76
!PlayerBlockedStatus_S00MUDLR = $77
!PlayerHide_DLUCAPLU = $78
!CurrentPlayer = $0DB3|!addr
!CapeImage = $13DF|!addr
!PlayerPose = $13E0|!addr
!PlayerSlope = $13E1|!addr
!SpinjumpTimer = $13E2|!addr
!PlayerWallRunningFlag = $13E3|!addr
!PlayerFrozenFlag = $13FB|!addr
!PlayerCarryingFlag = $1470|!addr
!PlayerCarryingFlagImage = $148F|!addr
!PlayerAnimationTimer = $1496|!addr
!PlayerFlashingTimer = $1497|!addr
!P1PowerUp = $0DB8|!addr
!P2PowerUp = $0DB9|!addr
!P1Lives = $0DB4|!addr
!P2Lives = $0DB5|!addr
!P1Coins = $0DB6|!addr
!P2Coins = $0DB7|!addr
!P1YoshiColor = $0DBA|!addr
!P2YoshiColor = $0DBB|!addr
!P1ItemBox = $0DBC|!addr
!P2ItemBox = $0DBD|!addr

;########################################
;############### Global #################
;########################################
!LockAnimationFlag = $9D
!HScrollEnable = $1411|!addr
!VScrollEnable = $1412|!addr
!HScrollLayer2Type = $1413|!addr
!VScrollLayer2Type = $1414|!addr
!WaterFlag = $85
!SlipperyFlag = $86
!GameMode = $0100|!addr
!TwoPlayersFlag = $0DB2|!addr

;########################################
;################ OAM ###################
;########################################
!TileXPosition200 = $0200|!addr
!TileYPosition200 = $0201|!addr
!TileCode200 = $0202|!addr
!TileProperty200 = $0203|!addr
!TileSize420 = $0420|!addr
!TileXPosition = $0300|!addr
!TileYPosition = $0301|!addr
!TileCode = $0302|!addr
!TileProperty = $0303|!addr
!TileSize460 = $0460|!addr

;########################################
;############### Yoshi ##################
;########################################
!YoshiX = $18B0|!addr
!YoshiY = $18B2|!addr
!YoshiKeyInMouthFlag = $191C|!addr

;########################################
;############## Clusters ################
;########################################
!ClusterNumber = $1892|!addr
!ClusterXLow = $1E16|!addr
!ClusterYLow = $1E02|!addr
!ClusterXHigh = $1E3E|!addr
!ClusterYHigh = $1E2A|!addr
!ClusterMiscTable1 = $0F4A|!addr
!ClusterMiscTable2 = $0F5E|!addr
!ClusterMiscTable3 = $0F72|!addr
!ClusterMiscTable4 = $0F86|!addr
!ClusterMiscTable5 = $0F9A|!addr
!ClusterMiscTable6 = $1E52|!addr
!ClusterMiscTable7 = $1E66|!addr
!ClusterMiscTable8 = $1E7A|!addr
!ClusterMiscTable9 = $1E8E|!addr

;########################################
;############## Extended ################
;########################################
!ExtendedNumber = $170B|!addr
!ExtendedXLow = $171F|!addr
!ExtendedYLow = $1715|!addr
!ExtendedXHigh = $1733|!addr
!ExtendedYHigh = $1729|!addr
!ExtendedXSpeed = $1747|!addr
!ExtendedYSpeed = $173D|!addr
!ExtendedXSpeedAccumulatingFraction = $175B|!addr
!ExtendedYSpeedAccumulatingFraction = $1751|!addr
!ExtendedBehindLayersFlag = $1779|!addr
!ExtendedMiscTable1 = $1765|!addr
!ExtendedMiscTable2 = $176F|!addr

;########################################
;############### Sprites ################
;########################################
!SpriteIndex = $15E9|!addr
!SpriteNumber = $9E
!SpriteStatus = $14C8
!SpriteXLow = $E4
!SpriteYLow = $D8
!SpriteXHigh = $14E0
!SpriteYHigh = $14D4
!SpriteXSpeed = $B6
!SpriteYSpeed = $AA
!SpriteXSpeedAccumulatingFraction = $14F8
!SpriteYSpeedAccumulatingFraction = $14EC
!SpriteDirection = $157C
!SpriteBlockedStatus_ASB0UDLR = $1588
!SpriteHOffScreenFlag = $15A0
!SpriteVOffScreenFlag = $186C
!SpriteHMoreThan4TilesOffScreenFlag = $15C4
!SpriteSlope = $15B8
!SpriteYoshiTongueFlag = $15D0
!SpriteInteractionWithObjectEnable = $15DC
!SpriteIndexOAM = $15EA
!SpriteProperties_YXPPCCCT = $15F6
!SpriteLoadStatus = $161A
!SpriteBehindEscenaryFlag = $1632
!SpriteInLiquidFlag = $164A
!SpriteDecTimer1 = $1540
!SpriteDecTimer2 = $154C
!SpriteDecTimer3 = $1558
!SpriteDecTimer4 = $1564
!SpriteDecTimer5 = $15AC
!SpriteDecTimer6 = $163E
!SpriteDecTimer7 = $1FE2
!SpriteTweaker1656_SSJJCCCC = $1656
!SpriteTweaker1662_DSCCCCCC = $1662
!SpriteTweaker166E_LWCFPPPG = $166E
!SpriteTweaker167A_DPMKSPIS = $167A
!SpriteTweaker1686_DNCTSWYE = $1686
!SpriteTweaker190F_WCDJ5SDP = $190F
!SpriteMiscTable1 = $0DF5|!addr
!SpriteMiscTable2 = $0E0B|!addr
!SpriteMiscTable3 = $C2
!SpriteMiscTable4 = $1504
!SpriteMiscTable5 = $1510
!SpriteMiscTable6 = $151C
!SpriteMiscTable7 = $1528
!SpriteMiscTable8 = $1534
!SpriteMiscTable9 = $1570
!SpriteMiscTable10 = $1594
!SpriteMiscTable11 = $1602
!SpriteMiscTable12 = $160E
!SpriteMiscTable13 = $1626
!SpriteMiscTable14 = $187B
!SpriteMiscTable15 = $1FD6

;########################################
;############### GIEPY ##################
;########################################
!ExtraBits = $7FAB10
!NewCodeFlag = $7FAB1C
!ExtraProp1 = $7FAB28
!ExtraProp2 = $7FAB34
!ExtraByte1 = $7FAB40
!ExtraByte2 = $7FAB4C
!ExtraByte3 = $7FAB58
!ExtraByte4 = $7FAB64
!ShooterExtraByte = $7FAB70
!GeneratorExtraByte = $7FAB78
!ScrollerExtraByte = $7FAB79
!CustomSpriteNumber = $7FAB9E
!ShooterExtraBits = $7FABAA
!GeneratorExtraBits = $7FABB2
!Layer1ExtraBits = $7FABB3
!Layer2ExtraBits = $7FABB4
!SpriteFlags = $7FABB5

if !sa1

!SpriteNumber = $3200
!SpriteYSpeed = $9E
!SpriteXSpeed = $B6
!SpriteMiscTable3 = $D8
!SpriteYLow = $3216
!SpriteXLow = $322C
!SpriteStatus = $3242
!SpriteYHigh = $3258
!SpriteXHigh = $326E
!SpriteYSpeedAccumulatingFraction = $74C8
!SpriteXSpeedAccumulatingFraction = $74DE
!SpriteMiscTable4 = $74F4
!SpriteMiscTable5 = $750A
!SpriteMiscTable6 = $3284
!SpriteMiscTable7 = $329A
!SpriteMiscTable8 = $32B0
!SpriteDecTimer1 = $32C6
!SpriteDecTimer2 = $32DC
!SpriteDecTimer3 = $32F2
!SpriteDecTimer4 = $3308
!SpriteMiscTable9 = $331E
!SpriteDirection = $3334
!SpriteBlockedStatus_ASB0UDLR = $334A
!SpriteMiscTable10 = $3360
!SpriteHOffScreenFlag = $3376
!SpriteDecTimer5 = $338C
!SpriteSlope = $7520
!SpriteHMoreThan4TilesOffScreenFlag = $7536
!SpriteYoshiTongueFlag = $754C
!SpriteInteractionWithObjectEnable = $7562
!SpriteIndexOAM = $33A2
!SpriteProperties_YXPPCCCT = $33B8
!SpriteMiscTable11 = $33CE
!SpriteMiscTable12 = $33E4
!SpriteLoadStatus = $7578
!SpriteMiscTable13 = $758E
!SpriteBehindEscenaryFlag = $75A4
!SpriteDecTimer6 = $33FA
!SpriteInLiquidFlag = $75BA
!SpriteTweaker1656_SSJJCCCC = $75D0
!SpriteTweaker1662_DSCCCCCC = $75EA
!SpriteTweaker166E_LWCFPPPG = $7600
!SpriteTweaker167A_DPMKSPIS = $7616
!SpriteTweaker1686_DNCTSWYE = $762C
!SpriteVOffScreenFlag = $7642
!SpriteMiscTable14 = $3410
!SpriteTweaker190F_WCDJ5SDP = $7658
!SpriteMiscTable15 = $766E
!SpriteDecTimer7 = $7FD6

!ExtraBits = $400040
!NewCodeFlag = $400056
!ExtraProp1 = $400057
!ExtraProp2 = $40006D
!ExtraByte1 = $4000A4
!ExtraByte2 = $4000BA
!ExtraByte3 = $4000D0
!ExtraByte4 = $4000E6
!ShooterExtraByte = $400110
!GeneratorExtraByte = $4000FC
!ScrollerExtraByte = $4000FD
!CustomSpriteNumber = $400083
!ShooterExtraBits = $400099
!GeneratorExtraBits = $4000A1
!Layer1ExtraBits = $4000A2
!Layer2ExtraBits = $4000A3
!SpriteFlags = $400118

endif 

;######################################
;############## Defines ###############
;######################################

!FrameIndex = !SpriteMiscTable1
!AnimationTimer = !SpriteDecTimer1
!AnimationIndex = !SpriteMiscTable2
!AnimationFrameIndex = !SpriteMiscTable3
!LocalFlip = !SpriteMiscTable4
!GlobalFlip = !SpriteMiscTable5

;######################################
;########### Init Routine #############
;######################################
print "INIT ",pc
	LDA #$00
	STA !GlobalFlip,x
	JSL InitWrapperChangeAnimationFromStart
    ;Here you can write your Init Code
    ;This will be excecuted when the sprite is spawned 
RTL

;######################################
;########## Main Routine ##############
;######################################
print "MAIN ",pc
    PHB
    PHK
    PLB
    JSR SpriteCode
    PLB
RTL

;>Routine: SpriteCode
;>Description: This routine excecute the logic of the sprite
;>RoutineLength: Short
Return:
RTS
SpriteCode:

    JSR GraphicRoutine                  ;Calls the graphic routine and updates sprite graphics

    ;Here you can put code that will be excecuted each frame even if the sprite is locked

    LDA !SpriteStatus,x			        
	CMP #$08                            ;if sprite dead return
	BNE Return	

	LDA !LockAnimationFlag				    
	BNE Return			                    ;if locked animation return.

    %SubOffScreen()

    ;JSR InteractMarioSprite
    ;After this routine, if the sprite interact with mario, Carry is Set.

    ;Here you can write your sprite code routine
    ;This will be excecuted once per frame excepts when 
    ;the animation is locked or when sprite status is not #$08

    JSR AnimationRoutine                ;Calls animation routine and decides the next frame to draw
    
    RTS

;>EndRoutine

;######################################
;######## Sub Routine Space ###########
;######################################

;Here you can write routines or tables

;Don't Delete or write another >Section Graphics or >End Section
;All code between >Section Graphics and >End Graphics Section will be changed by Dyzen : Sprite Maker
;>Section Graphics
;######################################
;########## Graphics Space ############
;######################################

;This space is for routines used for graphics
;if you don't know enough about asm then
;don't edit them.

;>Routine: GraphicRoutine
;>Description: Updates tiles on the oam map
;results will be visible the next frame.
;>RoutineLength: Short
GraphicRoutine:

    %GetDrawInfo()                     ;Calls GetDrawInfo to get the free slot and the XDisp and YDisp

    STZ !Scratch3                       ;$02 = Free Slot but in 16bits
    STY !Scratch2

    LDA !Scratch6
    ASL
    TAX                                 ;X = Frame Index

	LDA #$0010
    STA !Scratch8

    LDA FramesEndPosition,x
    STA !Scratch4                       ;$04 = End Position + A value used to select a frame version that is flipped

    LDA FramesStartPosition,x           
    TAX                                 ;X = Start Position
    SEP #$20                            ;A 8bits mode
    LDY !Scratch2                       ;Y = Free Slot
    CPY #$00FD
    BCS .return                         ;Y can't be more than #$00FD
-
    LDA Tiles,x
    STA !TileCode,y                     ;Set the Tile code of the tile Y

	LDA #$28
    STA !TileProperty,y                 ;Set the Tile property of the tile Y

    LDA !Scratch0
	CLC
	ADC XDisplacements,x
	STA !TileXPosition,y                ;Set the Tile x pos of the tile Y

    LDA !Scratch1
	CLC
	ADC YDisplacements,x
	STA !TileYPosition,y                ;Set the Tile y pos of the tile Y

    PHY
	REP #$20                                 
    TYA
    LSR
    LSR
    TAY                                 ;Y = Y/4 because size directions are not continuous to map 200 and 300
	SEP #$20
    LDA Sizes,x
    STA !TileSize460,y                  ;Set the Tile size of the tile Y
    PLY

    INY
    INY
    INY
    INY                                 ;Next OAM Slot
    CPY #$00FD
    BCS .return                         ;Y can't be more than #$00FD

    DEX
    BMI .return
    CPX !Scratch4                       ;if X < start position or is negative then return
    BCS -                               ;else loop

.return
    SEP #$10
    PLX                                 ;Restore X
    
    LDY #$FF                            ;Allows mode of 8 or 16 bits
    LDA !Scratch8                       ;Load the number of tiles used by the frame
    JSL $01B7B3|!rom                  		;This insert the new tiles into the oam, 
                                        ;A = #$00 => only tiles of 8x8, A = #$02 = only tiles of 16x16, A = #$04 = tiles of 8x8 or 16x16
                                        ;if you select A = #$04 then you must put the sizes of the tiles in !TileSize
RTS
;>EndRoutine

;All words that starts with '@' and finish with '.' will be replaced by Dyzen

;>Table: FramesStartPosition
;>Description: Indicates the index where starts each frame
;>ValuesSize: 16
FramesStartPosition:
    dw $0010,$0021,$0032,$0043,$0054,$0065,$0076,$0087,$0098,$00A9,$00BA,$00CB,$00DC,$00ED,$00FE,$010F
	dw $0120,$0131,$0142,$0153,$0164,$0175,$0186,$0197,$01A8,$01B9,$01CA,$01DB,$01EC
;>EndTable

;>Table: FramesEndPosition
;>Description: Indicates the index where end each frame
;>ValuesSize: 16
FramesEndPosition:
    dw $0000,$0011,$0022,$0033,$0044,$0055,$0066,$0077,$0088,$0099,$00AA,$00BB,$00CC,$00DD,$00EE,$00FF
	dw $0110,$0121,$0132,$0143,$0154,$0165,$0176,$0187,$0198,$01A9,$01BA,$01CB,$01DC
;>EndTable


;>Table: Tiles
;>Description: Tiles codes of each tile of each frame
;>ValuesSize: 8
Tiles:
    
Frame0_Life0_Tiles:
	db $90,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$80
	db $81
Frame1_Life1_Tiles:
	db $90,$B2,$B3,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$80
	db $81
Frame2_Life2_Tiles:
	db $90,$B4,$B5,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$80
	db $81
Frame3_Life3_Tiles:
	db $90,$B6,$B7,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$80
	db $81
Frame4_Life4_Tiles:
	db $90,$B8,$B9,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$80
	db $81
Frame5_Life5_Tiles:
	db $90,$B8,$B9,$B2,$B3,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$80
	db $81
Frame6_Life6_Tiles:
	db $90,$B8,$B9,$B4,$B5,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$80
	db $81
Frame7_Life7_Tiles:
	db $90,$B8,$B9,$B6,$B7,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$80
	db $81
Frame8_Life8_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$80
	db $81
Frame9_Life9_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B2,$B3,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$80
	db $81
Frame10_Life10_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B4,$B5,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$80
	db $81
Frame11_Life11_Tiles:
	db $90,$B8,$B9,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$80,$81,$B8,$B9,$B6
	db $B7
Frame12_Life12_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B0,$B1,$B0,$B1,$B0,$B1,$B0,$B1,$80
	db $81
Frame13_Life13_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B2,$B3,$B0,$B1,$B0,$B1,$B0,$B1,$80
	db $81
Frame14_Life14_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B4,$B5,$B0,$B1,$B0,$B1,$B0,$B1,$80
	db $81
Frame15_Life15_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B6,$B7,$B0,$B1,$B0,$B1,$B0,$B1,$80
	db $81
Frame16_Life16_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B0,$B1,$B0,$B1,$B0,$B1,$80
	db $81
Frame17_Life17_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B2,$B3,$B0,$B1,$B0,$B1,$80
	db $81
Frame18_Life18_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B4,$B5,$B0,$B1,$B0,$B1,$80
	db $81
Frame19_Life19_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B6,$B7,$B0,$B1,$B0,$B1,$80
	db $81
Frame20_Life20_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B0,$B1,$B0,$B1,$80
	db $81
Frame21_Life21_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B2,$B3,$B0,$B1,$80
	db $81
Frame22_Life22_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B4,$B5,$B0,$B1,$80
	db $81
Frame23_Life23_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B6,$B7,$B0,$B1,$80
	db $81
Frame24_Life24_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B0,$B1,$80
	db $81
Frame25_Life25_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B2,$B3,$80
	db $81
Frame26_Life26_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B4,$B5,$80
	db $81
Frame27_Life27_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B6,$B7,$80
	db $81
Frame28_Life28_Tiles:
	db $90,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$B8,$B9,$80
	db $81
;>EndTable

;>Table: XDisplacements
;>Description: X Displacement of each tile of each frame
;>ValuesSize: 8
XDisplacements:
    
Frame0_Life0_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame1_Life1_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame2_Life2_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame3_Life3_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame4_Life4_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame5_Life5_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame6_Life6_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame7_Life7_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame8_Life8_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame9_Life9_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame10_Life10_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame11_Life11_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame12_Life12_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame13_Life13_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame14_Life14_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame15_Life15_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame16_Life16_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame17_Life17_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame18_Life18_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame19_Life19_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame20_Life20_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame21_Life21_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame22_Life22_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame23_Life23_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame24_Life24_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame25_Life25_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame26_Life26_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame27_Life27_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
Frame28_Life28_XDisp:
	db $00,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00,$08,$00
	db $08
;>EndTable
;>Table: YDisplacements
;>Description: Y Displacement of each tile of each frame
;>ValuesSize: 8
YDisplacements:
    
Frame0_Life0_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame1_Life1_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame2_Life2_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame3_Life3_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame4_Life4_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame5_Life5_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame6_Life6_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame7_Life7_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame8_Life8_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$D8,$D8,$E0,$E0,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame9_Life9_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame10_Life10_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame11_Life11_YDisp:
	db $00,$F8,$F8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0,$C0,$F0,$F0,$E8
	db $E8
Frame12_Life12_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame13_Life13_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame14_Life14_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame15_Life15_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame16_Life16_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame17_Life17_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame18_Life18_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame19_Life19_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame20_Life20_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame21_Life21_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame22_Life22_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame23_Life23_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame24_Life24_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame25_Life25_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame26_Life26_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame27_Life27_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
Frame28_Life28_YDisp:
	db $00,$F8,$F8,$F0,$F0,$E8,$E8,$E0,$E0,$D8,$D8,$D0,$D0,$C8,$C8,$C0
	db $C0
;>EndTable
;>Table: Sizes.
;>Description: size of each tile of each frame
;>ValuesSize: 8
Sizes:
    
Frame0_Life0_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame1_Life1_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame2_Life2_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame3_Life3_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame4_Life4_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame5_Life5_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame6_Life6_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame7_Life7_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame8_Life8_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame9_Life9_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame10_Life10_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame11_Life11_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame12_Life12_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame13_Life13_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame14_Life14_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame15_Life15_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame16_Life16_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame17_Life17_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame18_Life18_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame19_Life19_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame20_Life20_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame21_Life21_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame22_Life22_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame23_Life23_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame24_Life24_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame25_Life25_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame26_Life26_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame27_Life27_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
Frame28_Life28_Sizes:
	db $02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
;>EndTable

;>End Graphics Section

;Don't Delete or write another >Section Animation or >End Section
;All code between >Section Animations and >End Animations Section will be changed by Dyzen : Sprite Maker
;>Section Animations
;######################################
;########## Animation Space ###########
;######################################

;This space is for routines used for graphics
;if you don't know enough about asm then
;don't edit them.
InitWrapperChangeAnimationFromStart:
	PHB
    PHK
    PLB
	STZ !AnimationIndex,x
	JSR ChangeAnimationFromStart
	PLB
	RTL

ChangeAnimationFromStart_LifeCharge:
	STZ !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life28:
	LDA #$01
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life27:
	LDA #$02
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life26:
	LDA #$03
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life25:
	LDA #$04
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life24:
	LDA #$05
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life23:
	LDA #$06
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life22:
	LDA #$07
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life21:
	LDA #$08
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life20:
	LDA #$09
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life19:
	LDA #$0A
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life18:
	LDA #$0B
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life17:
	LDA #$0C
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life16:
	LDA #$0D
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life15:
	LDA #$0E
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life14:
	LDA #$0F
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life13:
	LDA #$10
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life12:
	LDA #$11
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life11:
	LDA #$12
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life10:
	LDA #$13
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life9:
	LDA #$14
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life8:
	LDA #$15
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life7:
	LDA #$16
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life6:
	LDA #$17
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life5:
	LDA #$18
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life4:
	LDA #$19
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life3:
	LDA #$1A
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life2:
	LDA #$1B
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life1:
	LDA #$1C
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Life0:
	LDA #$1D
	STA !AnimationIndex,x


ChangeAnimationFromStart:
	STZ !AnimationFrameIndex,x

	STZ !Scratch1
	LDA !AnimationIndex,x
	STA !Scratch0					;$00 = Animation index in 16 bits

	STZ !Scratch3
	LDA !AnimationFrameIndex,x
	STA !Scratch2					;$02 = Animation Frame index in 16 bits

	STZ !Scratch5
	STX !Scratch4					;$04 = sprite index in 16 bits

	REP #$30						;A7X/Y of 16 bits
	LDX !Scratch4					;X = sprite index in 16 bits

	LDA !Scratch0
	ASL
	TAY								;Y = 2*Animation index

	LDA !Scratch2
	CLC
	ADC AnimationIndexer,y
	TAY								;Y = Position of the first frame of the animation + animation frame index

	SEP #$20						;A of 8 bits

	LDA Frames,y
	STA !FrameIndex,x				;New Frame = Frames[New Animation Frame Index]

	LDA Times,y
	STA !AnimationTimer,x			;Time = Times[New Animation Frame Index]

	LDA !Scratch2
	STA !AnimationFrameIndex,x

	SEP #$10						;X/Y of 8 bits
	LDX !Scratch4					;X = sprite index in 8 bits
RTS
	

;>Routine: AnimationRoutine
;>Description: Decides what will be the next frame.
;>RoutineLength: Short
AnimationRoutine:
    LDA !AnimationTimer,x
    BEQ +

	RTS

+
	STZ !Scratch1
	LDA !AnimationIndex,x
	STA !Scratch0					;$00 = Animation index in 16 bits

	STZ !Scratch3
	LDA !AnimationFrameIndex,x
	STA !Scratch2					;$02 = Animation Frame index in 16 bits

	STZ !Scratch5
	STX !Scratch4					;$04 = sprite index in 16 bits

	REP #$30						;A7X/Y of 16 bits
	LDX !Scratch4					;X = sprite index in 16 bits

	LDA !Scratch0
	ASL
	TAY								;Y = 2*Animation index

	INC !Scratch2					;New Animation Frame Index = Animation Frame Index + 1

	LDA !Scratch2			        ;if Animation Frame index < Animation Lenght then Animation Frame index++
	CMP AnimationLenght,y			;else go to the frame where start the loop.
	BCC +							

	LDA AnimationLastTransition,y
	STA !Scratch2					;New Animation Frame Index = first frame of the loop.

+
	LDA !Scratch2
	CLC
	ADC AnimationIndexer,y
	TAY								;Y = Position of the first frame of the animation + animation frame index

	SEP #$20						;A of 8 bits

	LDA Frames,y
	STA !FrameIndex,x				;New Frame = Frames[New Animation Frame Index]

	LDA Times,y
	STA !AnimationTimer,x			;Time = Times[New Animation Frame Index]

	LDA !Scratch2
	STA !AnimationFrameIndex,x

	SEP #$10						;X/Y of 8 bits
	LDX !Scratch4					;X = sprite index in 8 bits
RTS
;>EndRoutine

;All words that starts with '>' and finish with '.' will be replaced by Dyzen

AnimationLenght:
	dw $001D,$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001
	dw $0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001

AnimationLastTransition:
	dw $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	dw $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000

AnimationIndexer:
	dw $0000,$001D,$001E,$001F,$0020,$0021,$0022,$0023,$0024,$0025,$0026,$0027,$0028,$0029,$002A,$002B
	dw $002C,$002D,$002E,$002F,$0030,$0031,$0032,$0033,$0034,$0035,$0036,$0037,$0038,$0039

Frames:
	
Animation0_LifeCharge_Frames:
	db $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
	db $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C
Animation1_Life28_Frames:
	db $1C
Animation2_Life27_Frames:
	db $1B
Animation3_Life26_Frames:
	db $1A
Animation4_Life25_Frames:
	db $19
Animation5_Life24_Frames:
	db $18
Animation6_Life23_Frames:
	db $17
Animation7_Life22_Frames:
	db $16
Animation8_Life21_Frames:
	db $15
Animation9_Life20_Frames:
	db $14
Animation10_Life19_Frames:
	db $13
Animation11_Life18_Frames:
	db $12
Animation12_Life17_Frames:
	db $11
Animation13_Life16_Frames:
	db $10
Animation14_Life15_Frames:
	db $0F
Animation15_Life14_Frames:
	db $0E
Animation16_Life13_Frames:
	db $0D
Animation17_Life12_Frames:
	db $0C
Animation18_Life11_Frames:
	db $0B
Animation19_Life10_Frames:
	db $0A
Animation20_Life9_Frames:
	db $09
Animation21_Life8_Frames:
	db $08
Animation22_Life7_Frames:
	db $07
Animation23_Life6_Frames:
	db $06
Animation24_Life5_Frames:
	db $05
Animation25_Life4_Frames:
	db $04
Animation26_Life3_Frames:
	db $03
Animation27_Life2_Frames:
	db $02
Animation28_Life1_Frames:
	db $01
Animation29_Life0_Frames:
	db $00

Times:
	
Animation0_LifeCharge_Times:
	db $3C,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04
	db $04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$3C
Animation1_Life28_Times:
	db $04
Animation2_Life27_Times:
	db $04
Animation3_Life26_Times:
	db $04
Animation4_Life25_Times:
	db $04
Animation5_Life24_Times:
	db $04
Animation6_Life23_Times:
	db $04
Animation7_Life22_Times:
	db $04
Animation8_Life21_Times:
	db $04
Animation9_Life20_Times:
	db $04
Animation10_Life19_Times:
	db $04
Animation11_Life18_Times:
	db $04
Animation12_Life17_Times:
	db $04
Animation13_Life16_Times:
	db $04
Animation14_Life15_Times:
	db $04
Animation15_Life14_Times:
	db $04
Animation16_Life13_Times:
	db $04
Animation17_Life12_Times:
	db $04
Animation18_Life11_Times:
	db $04
Animation19_Life10_Times:
	db $04
Animation20_Life9_Times:
	db $04
Animation21_Life8_Times:
	db $04
Animation22_Life7_Times:
	db $04
Animation23_Life6_Times:
	db $04
Animation24_Life5_Times:
	db $04
Animation25_Life4_Times:
	db $04
Animation26_Life3_Times:
	db $04
Animation27_Life2_Times:
	db $04
Animation28_Life1_Times:
	db $04
Animation29_Life0_Times:
	db $04
;>End Animations Section

;Don't Delete or write another >Section Hitbox Interaction or >End Section
;All code between >Section Hitboxes Interaction and >End Hitboxes Interaction Section will be changed by Dyzen : Sprite Maker
;>Section Hitboxes Interaction
;>End Hitboxes Interaction Section